/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_CHECK_HPP
#define PXX_CHECK_HPP
#include <cstdlib>
#include <cstdio>

#define PXX_CHECK(cond)	\
	do { \
		if (!(cond)) { \
			fprintf(stderr, "%s:%d: %s(): Assertion failed: %s\n", \
				__FILE__, __LINE__, __func__, #cond); \
			abort(); \
		} \
	} while(0)

#define PXX_ABORT(s...) \
	do { \
		fprintf(stderr, "%s:%d: %s(): ", \
			__FILE__, __LINE__, __func__); \
		fprintf(stderr, s); \
		abort(); \
	} while(0)

#endif

