/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_CHOOSE_HPP
#define PXX_CHOOSE_HPP
#include <vector>

namespace p {

// ***************************************************
class choose {
public:
	choose();
	choose(int k, int m);
	~choose();
	
	void init(int k, int m);
	bool finished() const;
	bool pending() const;
	bool next();
	
	int operator[] (int i) const;

public:
	int k, m;
	std::vector<int> idx;
	bool ended;
};

// ***************************************************
class permute {

public:
	permute();
	permute(int n);
	permute(int n, int i, int j);
	permute(const permute &a);
	~permute();
	
	void id(int n);
	void id();
	
	void idswap(int i, int j);
	void swap(int i, int j);
	
	bool finished() const;
	bool pending() const;
	bool next();

	permute &operator++();
	permute operator++(int);
	
	int operator[] (int i) const;
	int &operator[] (int i);
	permute &operator=(const permute &a);
public:
	int n;
	std::vector<int> idx;
	bool ended;
};


// ***************************************************

} // namespace

#endif

