/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_CUT_POOL_HPP
#define PXX_CUT_POOL_HPP
#include <list>
#include "constraint.hpp"
#include "index_tracker.hpp"

namespace p {

// **************************************************

class cut : public constraint {

public:
	cut();
	cut(const cut &src);
	cut(const constraint &c);
	cut(const svec &row, char sense, double rhs);
	~cut();

	cut &operator=(const cut &src);

public:
	index_tracker tracker;
	int age;
};


// **************************************************
class cut_pool {

public:
	cut_pool();
	~cut_pool();
	
	void clear();
	
	cut &add();
	cut &add(const constraint &c);
	cut &add(const svec &row, char sense, double rhs);

public:
	std::list<cut> pool;
};


// **************************************************

} // namespace

#endif

