#include <iostream>
#include <cassert>
#include "pxx/dense_vector.hpp"
#include "pxx/sparse_vector.hpp"
#include "pxx/cplex_model.hpp"
#include "pxx/rational.hpp"
#include "pxx/strprintf.hpp"

int main(int argc, char **argv)
{
	/*p::rational q;
	
	q.approx(19.0/31.0 + 13.0/17.0, 1<<31);
	std::cout << q << std::endl;
	return(0);*/

	p::cplex_model cpxp;
	
	if (argc != 2) {
		std::cout << "Usage: pxx_test [problem]" << std::endl;
		return(0);
	}
	
	if (cpxp.readcopyprob(argv[1], NULL)) {
		std::cout << argv[1] << ": failed" << std::endl;
		return(1);
	}
	
	cpxp.lpopt();
	
	std::cout << cpxp.stat_str(cpxp.getstat()) << std::endl;
	
	int m = cpxp.getnumrows();
	int n = cpxp.getnumcols();

	p::dvec pi(m);
	p::dvec x(n);
	
	cpxp.getpi(&pi[0], 0, m - 1);
	cpxp.getx(&x[0], 0, n - 1);
	
	std::cout << "x  = " << x  << std::endl;
	std::cout << "pi = " << pi << std::endl;
	
	cpxp.freenb_driveout(1e+6, n);
	
	return(0);
}


