#include <iostream>
#include "pxx/cplex_model.hpp"
#include "query_problem.hpp"

//volatile int AbortOptimization;

int main(int argc, char **argv)
{
	if (argc != 2) {
		std::cout << "Usage: tworow <model>" << std::endl;
		return(0);
	}
	
	p::cplex_model a;
	p::cplex_model b;
	
	// read a problem
	if (a.readcopyprob(argv[1], NULL)) {
		std::cout << "Could not read " << argv[1] << std::endl;
		return(1);
	}
	
	a.fetch_columns();
	
	std::list<p::constraint> cl;
	
	int m = a.getnumrows();
	//int n = a.getnumcols();
	
	for (int i = 0; i < m; i++) {
		p::constraint g;
		
		a.get_constraint(i, g);
		
		cl.push_back(g);
	}
	
	// write b problem
	b.lower = a.lower;
	b.upper = a.upper;
	b.obj = a.obj;
	b.ctype = a.ctype;
	b.xnames = a.xnames;
	b.commit_columns();
	
	for (std::list<p::constraint>::iterator it = cl.begin(); it != cl.end(); it++) {
		b.add_constraint(*it);
	}
	
	a.writeprob("a.lp", NULL);
	b.writeprob("b.lp", NULL);

	return(0);
}

