#! /usr/bin/awk -f
#
# Usage: average.awk
#
# Print on stdout a copy of stdin, then a line showing the average and
# geometric mean of every numeric column
#

NF > 0 {
	if (NF > mc) {
		for (i = mc + 1; i <= NF; i++)
			geo[i] = 1.0
		mc = NF
	}
	
	#printf $1 " "
	for (i = 1; i <= NF; i++) {
		if (($i == "Y") || ($i == "_")) {
			if ($i == "Y")
				sum[i]++
			boolc[i] = 1
		} else if ($i == $i + 0) {
			sum[i] += $i
			geo[i] *= $i
			#printf $i ":" sum[i] " "
		} else {
			sk[i] = 1
		}
	}
	#printf "\n"

	lines = lines + 1
	print
}

END {
	for (i = 1; i <= mc; i++) {
		if (sk[i])
			printf "total "
		else if (boolc[i])
			printf "%.0f%% ", sum[i]
		else
			printf "%.3f ", sum[i]
	}
	printf "\n"

	for (i = 1; i <= mc; i++) {
		if (sk[i])
			printf "average "
		else if (boolc[i])
			printf "%.0f%% ", 100 * sum[i] / lines
		else
			printf "%.3f ", sum[i] / lines
	}
	printf "\n"

	for (i = 1; i <= mc; i++) {
		if (sk[i])
			printf "geometric "
		else if (boolc[i])
			printf "- ", 100 * sum[i] / lines
		else
			printf "%.3f ", geo[i] ^ (1.0 / lines)
	}
	printf "\n"
}

