#! /usr/bin/awk -f
#
# Usage: join.awk
#
# Read from stdin a series of files prepended with the special line
#
# 	file: {filename}
#
# and join them according to the content of the first column.
#
# The first j columns are considered common, where j is the number of
# comma-separated entries in 'common-columns'. If 'common-columns' is
# not specified, j defaults to one.
#

BEGIN {
	njcl = 1
}

/^file:/ {
	m = m + 1
	name[m] = $2
	next
}

NF > 0 {
	d = ""
	for (j = njcl + 1; j <= NF; j++) {
		d = d " " $j
	}
	
	tab[m, $1] = d
	all[$1] = all[$1] + 1

	#print name[m] ":" $1 ":" d
}

END {
	np = asorti(all, order)
	for (p = 1; p <= np; p++) {
		if (all[order[p]] == m) {
			printf "%s", order[p]
			for (i = 1; i <= m; i++) {
				printf "%s", tab[i, order[p]]
			}
			printf "\n"
		}
	}
}

