#! /usr/bin/awk -f
#
# Usage: tabular.awk
#
# Read a table from stdin and write it latex-formatted to stdout.
#

BEGIN {
	# begin table
	printf "\\begin{center}\n"
	printf "\\scriptsize\n"
	printf "\\begin{tabular}{r|"
	printf "}\n"
}

NF > 0 {
	gsub(/_/, "\\_", $0)
	gsub(/%/, "\\%", $0)
	gsub(/-0.00 /, "0.00 ", $0)
	gsub(/-0.00$/, "0.00", $0)

	if (($1 == "average") || ($1 == "geometric") || ($1 == "total")) {
		printf "\\hline\n%s", $1
	} else {
		printf "\\texttt{%s}", $1
	}
	
	for (i = 2; i <= NF; i++) {
		printf " & %s", $i
	}
	
	printf " \\\\\n"
}

END {
	printf "\\end{tabular}\n"
	printf "\\end{center}\n"
}

