#ifndef CONCAVE_HPP
#define CONCAVE_HPP
#include "pxx/cplex_model.hpp"

// ************************************************************************
// 
// ************************************************************************
double urand(double a, double b);

// ************************************************************************
// 
// ************************************************************************
class objective {

public:
	virtual ~objective() {};
	
	virtual double value(const p::dvec &x) = 0;
	virtual p::dvec gradient(const p::dvec &x) = 0;

};

// ************************************************************************
// 
// ************************************************************************
class concave_prob {

public:
	concave_prob(p::cplex_model &prob);
	~concave_prob();
	
	void opt(objective &obj);

public:
	p::cplex_model &prob;
	int n;
	p::dvec g, x;
};

#endif

