/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_TRACKER_HPP
#define PXX_TRACKER_HPP

namespace p {

// ************************************************
class index_tracker;
class index_target;

// ************************************************
class index_tracker {

public:
	index_tracker();
	~index_tracker();

private:
	index_tracker(const index_tracker &src);
	index_tracker &operator=(const index_tracker &src);

public:
	index_target *target;
	int index;

};

// ************************************************
class index_target {

public:
	index_target();
	~index_target();
	
	void clear();
	
	int size() const;
	int add();
	void remove(int i);

	void set_tracker(int i, index_tracker *tracker);
	void clear_tracker(int i);

private:
	std::vector<index_tracker *> tracker;

};




} // namespace

#endif
