/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "integers.hpp"

namespace p {

long gcd(long a, long b)
{
	long r;

	if (b < 0) b = -b;
	if (a < 0) a = -a;
	if (a < b) { r = a; a = b; b = r; }
	
	while (b) {
		r = a % b;
		a = b;
		b = r;
	}
	
	return(a);
}


}


