/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_MIP_DATABASE_HPP
#define PXX_MIP_DATABASE_HPP
#include <string>

namespace p {

class mipdb_entry {
public:
	mipdb_entry();
	mipdb_entry(const std::string &name);
	~mipdb_entry();
	
	bool find(const std::string &name);
	bool consistent(double val, double ref, double atol, double rtol);

public:
	std::string name;
	std::string source;
	double mip_value;
	double lp_value;
	bool known, mip_known, lp_known;
};


};

#endif

