/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_RATIONAL_HPP
#define PXX_RATIONAL_HPP
#include <iostream>

namespace p {

// **************************************
#define PXX_RATIONAL_DEFAULT_MAX_COEF	(1<<24)

class rational {

public:
	rational();
	rational(const rational &src);
	rational(const double &dbl);
	~rational();

	rational &operator=(const rational &src);
	rational &operator=(const double &dbl);

	void approx(double dbl, unsigned int max_coef);
	double get_double() const;
	
public:
	int num;
	unsigned int den;

};

std::ostream &operator<<(std::ostream &os, const rational &q);

// **************************************

} // namespace

#endif
