/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_TOLERANCE_HPP
#define PXX_TOLERANCE_HPP

namespace p {

class tolerance {

public:
	tolerance();
	tolerance(double tol0);
	tolerance(const tolerance &src);
	~tolerance();
	
	tolerance &operator=(const tolerance &src);
	
	bool equal(double a, double b) const;
	bool zero(double a) const;
	bool nonzero(double a) const;

	bool inclusive_le(double a, double b) const;
	bool exclusive_le(double a, double b) const;
	bool inclusive_ge(double a, double b) const;
	bool exclusive_ge(double a, double b) const;
	
	bool integral(double a) const;
	bool fractional(double a) const;

	double ceil(double a) const;
	double floor(double a) const;
	
public:
	double tol;
};


extern tolerance sparse_tol;
extern tolerance int_tol;

} // namespace



#endif

