/*
    This file is part of pxx -- modeling tools for optimization
    Copyright (C) 2011-2014  Laurent Poirrier

    libp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pxx.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PXX_Z2_HPP
#define PXX_Z2_HPP
#include <vector>

namespace p {

// **************************************************
struct z2_point {
	int x[2];
};

struct r2_point {
	double x[2];
};


class polytope2 {

public:
	int count_interior(const std::vector<r2_point> &v,
		double f[2], int l[2], int u[2], int max_pt, int max_iter);
	int count_interior_pre(const std::vector<r2_point> &v,
		double f[2], int l[2], int u[2], int max_pt, int max_iter);
	
	std::vector<z2_point> point;
};

// **************************************************

} // namespace

#endif

